unit support;

interface

type hex = string[4];

procedure Abort (message:string);
function GetMyName : string;
function Hex4 (x:word) : hex;
function Hex2 (x:byte) : hex;
function Decimal (x:hex) : word;

implementation

procedure Abort (message:string);
{ Abort the program and write an error message to the console. }

begin
{ change standard output to console }
close(output); assign(output,'CON'); rewrite(output);
writeln(message); halt(1);
end;

function GetMyName : string;

{ returns the file/pathname of the program itself, as it was used by the DOS
  to load the program. Probably this service works only in DOS 3.0 and higher }

type t=array [1..120] of char;
{ the explicite array type must be used here instead of 'string' in order for
  the program to work properly }

var EnvSeg:^word;
    s:^t;
    a:word;
    i:integer;

begin
EnvSeg:=Ptr(PrefixSeg,$2C);
a:=0;
{ look for bytes 00,00 - the end of the environment }
while not((mem[EnvSeg^:a]=0) and (mem[EnvSeg^:a+1]=0)) do a:=a+1;
a:=a+2;
{ if next bytes are 01,00 then the program name follows }
if (mem[EnvSeg^:a]=1) and (mem[EnvSeg^:a+1]=0) then
   begin
   s:=Ptr(EnvSeg^,a+2);
   i:=1; while s^[i]<>#0 do i:=i+1;
   GetMyName:=copy(s^,1,i-1)
   end
else GetMyName:=''
end;

function Hex4 (x:word) : hex;
{ convert word to 4 hex digits }

const digit:array[0..15] of char = '0123456789ABCDEF';
var result:string[4];
    i:integer;

begin
for i:=1 to 4 do
   begin
   result[5-i]:=digit[x mod 16];
   x:=x div 16;
   end;
result[0]:=#4;
hex4:=result;
end;

function Hex2 (x:byte) : hex;
{ convert byte to 2 hex digits }

begin
hex2:=copy(hex4(x),3,2);
end;

function Decimal (x:hex) : word;
{ convert 4 hex digits to word }

const zero=48;  { '0' }
         a=55;  { 'A'-10 }
var result:word;
    i:integer; z:char;

begin
result:=0;
for i:=1 to length(x) do
   begin
   result:=result*16;
   z:=UpCase(x[i]);
   case z of
      '0'..'9': result:=result+ord(z)-zero;
      'A'..'F': result:=result+ord(z)-a;
      else
         begin
         Decimal:=0; exit;
         end;
   end; { case }
   end;
Decimal:=result;
end;

begin end.
