program WAVinfo;

uses WAVhdr,support;

var ls:LoadStatus;
    f:file;
    Info:PCMWaveFormat;

begin
if paramcount=0 then abort('No filename specified');
ls:=LoadSample(f,paramstr(1),Info);
case ls of
  LS_LoadError: abort('Error reading file');
  LS_InvFormat: abort('Not a correct WAV file');
  LS_OK: with Info do
     begin
     writeln('File ',paramstr(1),':');
     write  ('Audio codec:     0x',hex4(wFormatTag));
     case wFormatTag of
        1:  write(' (Uncompressed PCM)');
        2:  write(' (Microsoft ADPCM)');
        6:  write(' (ITU G.711 a-law)');
        7:  write(' (ITU G.711 u-law)');
        17: write(' (IMA ADPCM)');
        20: write(' (ITU G.723 ADPCM)');
        49: write(' (GSM 6.10)');
        64: write(' (ITU G.721 ADPCM)');
        80: write(' (MPEG)');
        else write(' (Unknown)');
     end;
     writeln;
     writeln('No. of channels: ',nChannels);
     writeln('Sampling rate:   ',nSamplesPerSec,' Hz');
     writeln('Avg. bitrate:    ',nAvgBytesPerSec,' B/s (',nAvgBytesPerSec div 1000*8,' kbit/s)');
     writeln('Sample size:     ',wBitsPerSample,' bits');
     writeln('Block align:     ',nBlockAlign);
     close(f);
     end;
end;
end.
